CDECK  ID>, CHHBH3.
*CMZ :-        -17/07/03  18.11.30  by  Peter Richardson
*-- Author :   Chris Harris
C---------------------------------------------------------------------
      SUBROUTINE CHHBH3(PT,STAT,SPIN,BHCHRG)
C---------------------------------------------------------------------
C     Subroutine to select the type of the next particle
C---------------------------------------------------------------------
      IMPLICIT NONE
      INCLUDE 'charybdis1003.inc'
      INTEGER PT,STAT,SPIN,BHCHRG,CHFCHG,I
      DOUBLE PRECISION PTYPE,CHRGEN,EPS
      LOGICAL FIRST
      DATA FIRST/.TRUE./
      EXTERNAL CHRGEN,CHFCHG
      PARAMETER(EPS=1.0D-6)
C--initialisation on first call
      IF(FIRST) THEN
         PFERM (1) = PQUARK
         PFERM (2) = PFERM(1)+PLEPT
         PFERM (3) = PFERM(2)+PNEUT
         PBOSON(1) = PFERM(3)+PGLUON
         PBOSON(2) = PBOSON(1)+PWBOSN
         PBOSON(3) = PBOSON(2)+PZBOSN
         PBOSON(4) = PBOSON(3)+PHIGGS
         PBOSON(5) = PBOSON(4)+PGAMMA
C--check the sum
         IF(ABS(PBOSON(5)-1.0D0).GT.EPS) THEN
            IF(IBHPRN.GE.1) THEN
               print *,'WARNING PROBABILITIES DO NOT SUM TO ONE'
               print *,'RENORMALISING'
            ENDIF
            DO I=1,3
               PFERM(I) = PFERM(I)/PBOSON(5)
               PBOSON(I) = PBOSON(I)/PBOSON(5)
            ENDDO
            PBOSON(4) = PBOSON(4)/PBOSON(5)
            PQUARK = PQUARK/PBOSON(5)
            PLEPT  = PLEPT /PBOSON(5)
            PNEUT  = PNEUT /PBOSON(5)
            PGLUON = PGLUON/PBOSON(5)
            PGAMMA = PGAMMA/PBOSON(5)
            PZBOSN = PZBOSN/PBOSON(5)
            PWBOSN = PWBOSN/PBOSON(5)
            PHIGGS = PHIGGS/PBOSON(5)
            PBOSON(5) = 1.0D0
         ENDIF
         FIRST = .FALSE.
      ENDIF
C--Assume decay product is a fermion
      STAT=-1
      SPIN=1
C--Choose decay product
      PTYPE=CHRGEN(2)
C--Change STAT to 1 and SPIN to 2 if we have a boson instead
C--except for one degree of freedom of massive gauge bosons
      IF (PTYPE.GE.PFERM(3)) THEN
         STAT=1
         SPIN=2
         IF ((PTYPE.GE.PBOSON(1)).AND.(PTYPE.LT.PBOSON(3))) THEN
            IF (3*CHRGEN(3).LT.1.0d0) SPIN=0
         ENDIF
      ENDIF
C--Choose particle type
      IF (PTYPE.LT.PFERM(1)) THEN
C--Quarks
         PT=1+INT(6*PTYPE/PFERM(1))
C--Ensure BH charge remains close to 0, and antiparticles half time
         IF (((CHFCHG(PT)*BHCHRG).LT.0).OR.
     &       ((BHCHRG.EQ.0).AND.(CHRGEN(4).LT.0.5D0))) THEN 
            PT=-PT
         ENDIF
      ELSEIF (PTYPE.LT.PFERM(2)) THEN
C--Leptons
         PT=11+2*INT(3*(PTYPE-PFERM(1))/PLEPT)
C--Ensure BH charge remains close to 0, and antiparticles half time
         IF (((CHFCHG(PT)*BHCHRG).LT.0).OR.
     &       ((BHCHRG.EQ.0).AND.(CHRGEN(4).LT.0.5D0))) THEN 
            PT=-PT
         ENDIF
      ELSEIF (PTYPE.LT.PFERM(3)) THEN
C--Neutrinos
         PT=12+2*INT(3*(PTYPE-PFERM(2))/PNEUT)
         IF(CHRGEN(4).LT.0.5D0) PT = -PT
      ELSEIF (PTYPE.LT.PBOSON(1)) THEN
C--Gluons
         PT=21
      ELSEIF (PTYPE.LT.PBOSON(2)) THEN
C--W+/W-
         PT=24
C--Ensure BH charge remains close to 0, and antiparticles half time
         IF (((CHFCHG(PT)*BHCHRG).LT.0).OR.
     &       ((BHCHRG.EQ.0).AND.(CHRGEN(4).LT.0.5D0))) THEN 
            PT=-PT
         ENDIF
      ELSEIF (PTYPE.LT.PBOSON(3)) THEN
C--Z0
         PT=23
      ELSEIF (PTYPE.LT.PBOSON(4)) THEN
C--Higgs
         PT=25
         SPIN=0
      ELSE
C--Photons
         PT=22
      ENDIF
C--Calculate new charge of BH
      BHCHRG=BHCHRG-CHFCHG(PT)
      END
